// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXN = 500'000;
int MAXM = 500'000;

const int MAXA = 1'000'000'000;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);

    if (validator.group() == "4") {
        MAXN = MAXM = 1000;
    }

    int n = inf.readInt(1, MAXN, "n");
    inf.readSpace();
    int m = inf.readInt(1, MAXM, "m");
    inf.readSpace();
    int k = inf.readInt(1, min(n, m), "k");
    inf.readEoln();

    if (validator.group() == "2") {
        ensuref(m == k, "in group #2 m = k");
    }

    if (validator.group() == "3") {
        ensuref(k == 1, "in group #3 k = 1");
    }

    vector<int> arr;
    for (int i = 0; i < n; ++i) {
        int num = inf.readInt(0, MAXA, format("a_%d", i + 1));
        arr.push_back(num);
        if (i < n - 1) {
            inf.readSpace();
        }
    }

    if (validator.group() == "1") {
        sort(arr.begin(), arr.end());
        ensuref(unique(arr.begin(), arr.end()) == arr.end(), "in group #1 all a_i should be different");
    }

    inf.readEoln();

    inf.readEof();

    return 0;
}